;  Test INTIM as a Loop Counter
;  By Omegamatrix


LOOP_COUNT  = 64  ; max is 64

      processor 6502

WSYNC   =  $02
INTIM   =  $0284
TIM1T   =  $0294

       ORG $F000

START:
    cld
    ldx    #0
    txa
.loopClear:
    dex
    txs
    pha
    bne    .loopClear


    lda    #(76*LOOP_COUNT - (LOOP_COUNT/4)*256 - (LOOP_COUNT/21)*256)
    sta    $FF         ; holds value loaded into TIM1T for easy reference in the debugger
    sta    WSYNC
;---------------------------------------
    sta    TIM1T

    ldy    #LOOP_COUNT

.loopFillTime:
    sta    WSYNC
;---------------------------------------
    ldx    INTIM
    stx    $7F,Y      ; $80 holds final value (always 0), $81 holds second last value, etc...
    dey
    txa
    bne    .loopFillTime

.loopForever:
    beq    .loopForever


;all values as seen in the stella debugger
;
;   $00,$4C,$98,$E4,  $30,$7C,$C8,$14,  $60,$AC,$F8,$44,  $90,$DC,$28,$74
;   $C0,$0C,$58,$A4,  $F0,$3C,$88,$D4,  $20,$6C,$B8,$04,  $50,$9C,$E8,$34
;   $80,$CC,$18,$64,  $B0,$FC,$48,$94,  $E0,$2C,$78,$C4,  $10,$5C,$A8,$F4
;   $40,$8C,$D8,$24,  $70,$BC,$08,$54,  $A0,$EC,$38,$84,  $D0,$1C,$68,$B4
;
;same table as above, in decimal...
;goes from 0 to 252 in steps of 4
;
;      0,76,152,228,    48,124,200,20,   96,172,248,68,    144,220,40,116
;     192,12,88,164,   240,60,136,212,    32,108,184,4,     80,156,232,52
;    128,204,24,100,   176,252,72,148,  224,44,120,196,     16,92,168,244
;     64,140,216,36,     112,188,8,84,  160,236,56,132,    208,28,104,180



       ORG $FFFC

    .word START
    .word START